#!/usr/bin/perl -w

my $db_file = shift @ARGV || '';
my $sql_file = shift @ARGV || '';

use db_sqlite;

use Fcntl;
use DBI;

# debugging on/off
my $d = 0;

my $error = 0;
my $errormsg = '';
my @sql_queries = ();
my $sql_query = '';

if ( !$db_file ) { $error = 1; $errormsg .= "No db_file found\n"; }
if ( !$sql_file ) { $error = 1; $errormsg .= "No sql_file found\n"; }

if ( $error ) { usageanddie($errormsg); }

# my $dbh = open_db_sqlite2($db_file);
my $dbh = open_db_sqlite($db_file);

if ( $dbh =~ /^ERROR/ )
{
    print STDERR <<EOF;
Error while opening database: $dbh
EOF
    exit 1;
}

open ( IN, "$sql_file" ) || die "could not open sql_file $sql_file : $!\n";
while (<IN>)  { $sql_query .= $_; }
close(IN);


# abschicken
        my $query =<<EOF;
$sql_query
EOF

print "call:\n$query\n";
    $sth = $dbh->prepare($query);

    $sth->execute() or die "ERROR: Cannot execute: " . $sth->errstr();
    $sth->finish();
    



my $db_close_error = close_db($dbh);

if ( $db_close_error )
{
    print STDERR <<EOF;
Error while losing database: $db_close_error
EOF
    exit 1;
}


sub usageanddie
{
    my $msg = shift || '';
    if ( $msg )
    {
        print STDERR $msg."\n";
    }

    print STDERR <<EOF;

usage: $0 <db_file> <sql-file>

      db_file: which db to open
     sql-file: file with sql-queries who should be executed
EOF
    exit 1;
}

exit 0;
