
package Neko::config;

use strict;
use Exporter;
use vars qw (@ISA @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw( 
               read_config
               save_config
	    );

# ######################################################################
# my %data = read_config(<file>);
sub read_config
{
    my $file = shift || '';
    my %returnwert = ();


    # returnwert initialisieren
    $returnwert{'errorcode'} = 0;
    $returnwert{'errormsg'} = '';

    if ( !$file ) 
    { 
        $returnwert{'errorcode'} = 1;
        $returnwert{'errormsg'} = 'no config file, use: %data = read_config(file);';
        return %returnwert; 
    }

    open (IN, "$file") || do 
        {
	    $returnwert{'errorcode'} = 2;
            $returnwert{'errormsg'} = 'read_config: could not open config file: '.$!."\n";
	};

    if ( $returnwert{'errorcode'} )
    { return %returnwert; }

    while (<IN>)
    {
	chomp $_;
        if ( /^\s*$/ ) { next; }
        if ( /^\s*\#/ ) { next; }
	my ( $key, $value ) = split /:/, $_, 2;

	# cut spaces around $key and $value
	$key =~ s/^\s+//g;
	$key =~ s/\s+$//g;
	$value =~ s/^\s+//g;
	$value =~ s/\s+$//g;
        $returnwert{'data'}{$key} = $value;
    }

    close(IN);

    return %returnwert; 
}

# my %retcode = save_config($file, $data_hash_ref);
sub save_config
{
    my $file = shift || '';
    my $data = shift || '';
    my %returnwert = ();

    # returnwert initialisieren
    $returnwert{'errorcode'} = 0;
    $returnwert{'errormsg'} = '';

    if ( !$file ) 
    { 
        $returnwert{'errorcode'} = 1;
        $returnwert{'errormsg'} = 'no config file, use: %retcode = save_config(file);';
        return %returnwert; 
    }

    open (OUT, ">$file") || do 
        {
	    $returnwert{'errorcode'} = 2;
            $returnwert{'errormsg'} = 'save_config: could not open config file for writing: '.$!."\n";
	};

    if ( $returnwert{'errorcode'} )
    { return %returnwert; }

    foreach my $k ( sort keys %{$data} )
    { print OUT "$k:$data->{$k}\n"; }

    close(OUT);

    return %returnwert; 
}
# ######################################################################
1;
